// https://software.intel.com/sites/products/documentation/doclib/mkl_sa/11/mkl_lapack_examples/sgesv_ex.c.htm

//https://www.netlib.org/lapack/lapacke.html

#include <stdio.h>
#include <lapacke.h>

int main()
{
      int i;
      lapack_int INFO;
      lapack_int m=3, lda=3,ldb=3,nrhs=1;
      int IPIV[m];

//  The elements of A are columns
      float A[][3]={{1,4,3},{2,5,8},{3,6,9}};
      // A[column][row]

      float B[] ={1,0,-1};

      for(i =0;i<m;i++){
         printf(" %f %f %f \n",A[0][i],A[1][i],A[2][i]);
      // A[column][row]
      }

      printf("\n"); 

      for(i =0;i<m;i++){
         printf(" %f \n",B[i]);
      }

      LAPACKE_sgesv(LAPACK_COL_MAJOR,m,nrhs,*A,lda,IPIV,B,ldb);


      printf("Solve the system.  INFO = %d\n",INFO);
      printf("INFO = 0 is success, INFO > 0 means A is singular\n");
      for(i =0;i<m;i++){
         printf(" %f %f %f \n",A[0][i],A[1][i],A[2][i]);
      // A[column][row]
      }
      printf("\n");

      for(i =0;i<m;i++){
         printf(" %f \n",B[i]);
      }

      return 0;

}
